/* atname --- build a file name from the specified time */

#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/param.h>
#include <sys/time.h>

#include "at.h"

static char buf[64];

char *
atname(filetime, seqno)

time_t filetime;
int seqno;

{
	sprintf(buf, "%d.%d", filetime, seqno);
	return(buf);
}

/* -------------------------------------------------------------------------- */

atseq()

{
	char seqfile[MAXPATHLEN];

	int seqno;
	int sq_handle;

	sprintf(seqfile, "%s/%s", ATDIR, SEQUENCE);

	if ((sq_handle = open(seqfile, O_RDWR | O_CREAT, 0640)) < 0 ||
			lockf(sq_handle, F_LOCK, 0L) < 0) {

		perror(seqfile);
		exit(1);
	}

	if (read(sq_handle, buf, sizeof(buf)) > 0) {

		seqno = atoi(buf) + 1;

		if (seqno > MAX_JOBNO)
			seqno = 1;

		if (lseek(sq_handle, (off_t)0, 0) < 0) {

			perror(seqfile);
			exit(1);
		}
	}

	else
		seqno = 1;
	
	sprintf(buf, "%d\n", seqno);
	write(sq_handle, buf, strlen(buf));
	close(sq_handle);

	return(seqno);
}
