/* dumpenv --- dump the environment in a usable form to a file */

#include <stdio.h>

dumpenv(envp, fp)

char *envp[];
FILE *fp;

{
	char varname[512];
	register char *ch;
	register char **string;

	/* Loop through all of the environment variables */

	for (string = envp ; *string != NULL ; string++) {

		/* Skip the TERM variable */

		if (strncmp(*string, "TERM=", 5) == 0)
			continue;

		/* Copy the variable name to output, looking for the equal sign */

		for (ch = *string ; *ch != '\0' ; ch++) {

			fputc(*ch, fp);

			if (*ch == '=') {

				int len;

				/* Equal sign found, save the variable name */

				len = ch - *string;
				strncpy(varname, *string, len);
				varname[len] = '\0';
				break;
			}
		}

		/* Quote the variable's value */

		fputc('\'', fp);

		for (ch++ ; *ch != '\0' ; ch++) {

			/* Quote any single quotes in the variable's value */

			if (*ch == '\'')
				fputs("'\\''", fp);
			else
				fputc(*ch, fp);
		}

		fprintf(fp, "'\nexport %s\n", varname);
	}
}
